// Code scaffolded by goctl. Safe to edit.
// goctl 1.9.2

package auth

import (
	"net/http"

	"juwan-backend/app/users/api/internal/logic/auth"
	"juwan-backend/app/users/api/internal/svc"
	"juwan-backend/app/users/api/internal/types"

	"github.com/zeromicro/go-zero/rest/httpx"
)

// 用户注册
func RegisterHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		var req types.RegisterReq
		if err := httpx.Parse(r, &req); err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
			return
		}

		l := auth.NewRegisterLogic(r.Context(), svcCtx)
		resp, token, err := l.Register(&req)
		if err != nil {
			httpx.ErrorCtx(r.Context(), w, err)
		} else {
			http.SetCookie(w, &http.Cookie{
				Name:        "JToken",
				Value:       token,
				Quoted:      false,
				Path:        "/",
				Domain:      "",
				RawExpires:  "",
				MaxAge:      691200,
				Secure:      false,
				HttpOnly:    true,
				SameSite:    http.SameSiteStrictMode,
				Partitioned: false,
			})
			httpx.OkJsonCtx(r.Context(), w, resp)
		}
	}
}
